import java.util.ArrayList;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;


public class AxisDialog {
	private Shell shell;
	private ArrayList txtVarX, txtVarY;
	private ArrayList chkShowTrace, txtRadius;
	private Text txtXFrom, txtXTo, txtYFrom, txtYTo;
	private String[] varX, varY;
	private boolean[] showTrace;
	private double xFrom, xTo, yFrom, yTo;
	private Composite varsCom;
	private String[] radius;

	private void addVarControls(String varX, String varY, String radius, boolean showTrace) {
		Text text = new Text(varsCom, SWT.BORDER);
		text.setText(varX);
		GridData data = new GridData();
		data.widthHint = 50;
		data.horizontalAlignment = GridData.CENTER;
		text.setLayoutData(data);
		txtVarX.add(text);
		
		text = new Text(varsCom, SWT.BORDER);
		text.setText(varY);
		data = new GridData();
		data.widthHint = 50;
		data.horizontalAlignment = GridData.CENTER;
		text.setLayoutData(data);
		txtVarY.add(text);
		
		text = new Text(varsCom, SWT.BORDER);
		text.setText(radius);
		data = new GridData();
		data.widthHint = 50;
		data.horizontalAlignment = GridData.CENTER;
		text.setLayoutData(data);
		txtRadius.add(text);

		Button button = new Button(varsCom, SWT.CHECK);
		button.setSelection(showTrace);
		data = new GridData();
		data.horizontalAlignment = GridData.CENTER;
		button.setLayoutData(data);
		chkShowTrace.add(button);
	}
	private void createContents() {
		GridLayout l = new GridLayout(4, false);
		l.marginHeight = l.marginWidth = 10;
		l.horizontalSpacing = 5; 
		l.verticalSpacing = 10;
		GridData data;
		shell.setLayout(l);
		
		Group group= new Group(shell, SWT.NULL);
		group.setText("ѿ");
		data = new GridData();
		data.horizontalSpan = 4;
		data.horizontalAlignment= GridData.CENTER;
		group.setLayoutData(data);
		group.setLayout(new GridLayout(1, false));
		
		varsCom = new Composite(group, SWT.NULL);
		l = new GridLayout(4, false);
		l.verticalSpacing = 5;
		varsCom.setLayout(l);
		
		Label label = new Label(varsCom, SWT.NULL);
		label.setText("");
		data = new GridData();
		data.horizontalAlignment = GridData.CENTER;
		label.setLayoutData(data);
		
		label = new Label(varsCom, SWT.NULL);
		label.setText("ļ");
		data = new GridData();
		data.horizontalAlignment = GridData.CENTER;
		label.setLayoutData(data);
		
		label = new Label(varsCom, SWT.NULL);
		label.setText("Ⱦ");
		data = new GridData();
		data.horizontalAlignment = GridData.CENTER;
		label.setLayoutData(data);

		label = new Label(varsCom, SWT.NULL);
		label.setText("פɽ");
		data = new GridData();
		data.horizontalAlignment = GridData.CENTER;
		label.setLayoutData(data);
		
		txtVarX = new ArrayList();
		txtVarY = new ArrayList();
		chkShowTrace = new ArrayList();
		txtRadius = new ArrayList();
		for (int i = 0; i < varX.length; i++) {
			addVarControls(varX[i], varY[i], radius[i], showTrace[i]);
		}

		Composite com = new Composite(group, SWT.NULL);
		com.setLayout(new FillLayout());
		data = new GridData();
		data.horizontalAlignment = GridData.END;
		data.widthHint = 70;
		com.setLayoutData(data);
		
		Button button = new Button(com, SWT.NULL);
		button.setText("ɲ");
		button.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				addVarControls("", "", "", false);
				shell.pack();
			}
		});
		
		label = new Label(shell, SWT.NULL);
		label.setText("ϰ");
		
		txtXFrom = new Text(shell, SWT.BORDER);
		txtXFrom.setText(Double.toString(xFrom));
		data = new GridData();
		data.widthHint = 50;
		txtXFrom.setLayoutData(data);
		
		label = new Label(shell, SWT.NULL);
		label.setText("-");

		txtXTo = new Text(shell, SWT.BORDER);
		txtXTo.setText(Double.toString(xTo));
		data = new GridData();
		data.widthHint = 50;
		txtXTo.setLayoutData(data);

		label = new Label(shell, SWT.NULL);
		label.setText("ļϰ");
		
		txtYFrom = new Text(shell, SWT.BORDER);
		txtYFrom.setText(Double.toString(yFrom));
		data = new GridData();
		data.widthHint = 50;
		txtYFrom.setLayoutData(data);

		label = new Label(shell, SWT.NULL);
		label.setText("-");

		txtYTo = new Text(shell, SWT.BORDER);
		txtYTo.setText(Double.toString(yTo));
		data = new GridData();
		data.widthHint = 50;
		txtYTo.setLayoutData(data);
		
		com = new Composite(shell, SWT.NULL);
		data = new GridData();
		data.horizontalAlignment = GridData.END;
		data.horizontalSpan = 10;
		com.setLayoutData(data);
		l = new GridLayout(2, true);
		com.setLayout(l);

		button = new Button(com, SWT.PUSH);
		button.setText("OK");
		shell.setDefaultButton(button);
		data = new GridData();
		data.horizontalAlignment = GridData.FILL;
		button.setLayoutData(data);
		button.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				//ꤵƤԤοĴ٤
				int count = 0;
				for (int i = 0; i < txtVarX.size(); i++) {
					Text x = (Text)txtVarX.get(i);
					Text y = (Text)txtVarY.get(i);
					if (!x.getText().equals("") || !y.getText().equals("")) {
						count++;
					}
				}
				//ꤵƤԤʬΤߡѿͤ򥳥ԡ
				varX = new String[count];
				varY = new String[count];
				showTrace = new boolean[count];
				radius = new String[count];
				int j = 0;
				for (int i = 0; i < txtVarX.size(); i++) {
					Text x = (Text)txtVarX.get(i);
					Text y = (Text)txtVarY.get(i);
					if (!x.getText().equals("") || !y.getText().equals("")) {
						varX[j] = x.getText();
						varY[j] = y.getText();
						showTrace[j] = ((Button)chkShowTrace.get(i)).getSelection();
						radius[j] = ((Text)txtRadius.get(i)).getText();
						j++;
					}
				}
				xFrom = Double.parseDouble(txtXFrom.getText());
				xTo = Double.parseDouble(txtXTo.getText());
				yFrom = Double.parseDouble(txtYFrom.getText());
				yTo = Double.parseDouble(txtYTo.getText());
				shell.close();
			}
		});
		
		button = new Button(com, SWT.PUSH);
		button.setText("Cancel");
		data = new GridData();
		data.horizontalAlignment = GridData.FILL;
		button.setLayoutData(data);
		button.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				shell.close();
			}
		});
		
		shell.pack();
	}
	
	public void openDialog(Shell parent) {
		shell = new Shell(parent, SWT.BORDER | SWT.TITLE | SWT.APPLICATION_MODAL);
		createContents();
		shell.open();
		Display display = shell.getDisplay();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}
	
	public void setVarX(String[] vars) {
		varX = vars;
	}
	public void setVarY(String[] vars) {
		varY = vars;
	}
	public void setXFrom(double val) {
		xFrom = val;
	}
	public void setXTo(double val) {
		xTo = val;
	}
	public void setYFrom(double val) {
		yFrom = val;
	}
	public void setShowTrace(boolean[] data) {
		showTrace = data;
	}
	public void setYTo(double val) {
		yTo = val;
	}
	public void setRadius(String[] data) {
		radius = data;
	}
	public String[] getVarX() {
		return varX;
	}
	public String[] getVarY() {
		return varY;
	}
	public double getXFrom() {
		return xFrom;
	}
	public double getXTo() {
		return xTo;
	}
	public double getYFrom() {
		return yFrom;
	}
	public double getYTo() {
		return yTo;
	}
	public boolean[] getShowTrace() {
		return showTrace;
	}
	public String[] getRadius() {
		return radius;
	}
	
	public void open() {
		shell.open();
	}
}
