import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Data {
	private List list = Collections.synchronizedList(new ArrayList());
	private Map map = Collections.synchronizedMap(new HashMap());
	
	public void clear() {
		list.clear();
		map.clear();
		blockStart = 0;
	}

	public int size() {
		return list.size();
	}
	public double getTime(int index) {
		return ((Field)list.get(index)).time;
	}
	public Interval get(int index, String var) {
		Field f = (Field)list.get(index);
		Integer i = (Integer)map.get(var);
		if (i == null) {
			if (index <= blockStart) {
				//ǡʤä
				return Interval.UNDEFINED;
			} else {
				//ǡϤޤʤɲä뤫⤷ʤ
				return null;
			}
		} else {
			return f.get(i.intValue());
		}
	}
	public void set(double time, String var, Interval val) {
		//֤θ
		//Ǹ˶ᤤˤϤʤΤǡǸ夫õO(1)ΤϤ
		int i = list.size() - 1;
		while (i >= 0 && ((Field)list.get(i)).time >= time) {
			i--;
		}
		i++;
		//Ǥ˽λ֥åؤν񤭹
		if (i < blockStart) {
			throw new RuntimeException("invalid data : added data to already finished block\n" +
					"blockStart : " + blockStart + "\tindex : " + i);
		}
		Field f = null;
		if (i < list.size()) {
			f = (Field)list.get(i); //f.timeϡtimeƱtimeʾǺǾʪ
		}
		if (f == null || f.time > time) {
			f = new Field();
			f.time = time;
			list.add(i, f);
		}

		//var -> index
		int j;
		if (map.containsKey(var)) {
			j = ((Integer)map.get(var)).intValue();
		} else {
			j = map.size();
			map.put(var, new Integer(j));
		}
		
		f.set(j, val);
	}
	private int blockStart = 0;
	public void endBlock() {
		int count = map.size();
		for (int i = blockStart; i < list.size(); i++) {
			Field f = (Field)list.get(i);
			int j;
			for (j = 0; j < f.vals.size(); j++) {
				if (f.vals.get(j) == null) { 
					f.vals.set(j, Interval.UNDEFINED);
				}
			}
			for (; j < count; j++) {
				f.vals.add(Interval.UNDEFINED);
			}
		}
		blockStart = list.size() - 1; //Խʣ
		if (blockStart == -1) {
			blockStart = 0;
		}
	}
	
	private static class Field {
		double time;
		ArrayList vals = new ArrayList();
		void set(int j, Interval val) {
			while (!(j < vals.size())) {
				vals.add(null);
			}
			vals.set(j, val);
		}
		Interval get(int j) {
			if (j < vals.size()) {
				return (Interval)vals.get(j);
			} else {
				return null;
			}
		}
	}
}
