import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

import org.eclipse.swt.SWT;
import org.eclipse.swt.SWTException;
import org.eclipse.swt.widgets.*;

public class DataReader implements Runnable {
	private boolean executing = false;
	private String command;
	private Data data = new Data();
	private Shell shell;
	private Thread thread;
	private Button btnStop;
	public DataReader(Shell shell, Button btnStop) {
		this.shell = shell;
		this.btnStop = btnStop;
	}
	public Data getData() {
		return data;
	}
	
	public boolean execute(String command) {
		synchronized (this) {
			if (executing) {
				return false;
			}
			executing = true;
			flgStop = false;
		}
		btnStop.setEnabled(true);
		this.command = command;
		clear();
		thread = new Thread(this);
		thread.start();
		
		return true;
	}

	public boolean isExecuting() {
		return executing;
	}
	public void clear() {
		outputString.delete(0, outputString.length());
		data.clear();
	}
	private boolean flgStop;
	public void stop() {
		synchronized (this) {
			if (executing) {
				flgStop = true;
			} else {
				return;
			}
		}
	}
	public void join() {
		if (thread == null) {
			return;
		}
		try {
			thread.join();
		} catch (InterruptedException e) {
			e.printStackTrace(); //ʤ
			throw new RuntimeException("Unexpected Interruption", e);
		}
	}
	private StringBuffer outputString = new StringBuffer();
	public String getOutputString() {
		return outputString.toString();
	}
	
	private Process p;
	public void run() {
		p = null;
		try {
			p = Runtime.getRuntime().exec(command);
			BufferedReader reader = new BufferedReader(new InputStreamReader(p.getInputStream()));
			
			String var = null;
			while (true) {
				if (flgStop) {
					return;
				}
				String buf = reader.readLine();
				if (buf == null) {
					break;
				}
				//ΤޤɸϤˤ񤭽Ф
				outputString.append(buf + "\n");

				if (buf.equals("Max time!")) {
					//֤ΥǡλΤǡǡʤäѿͤ(-infty,infty)ˤ
					data.endBlock();
				} else if (buf.endsWith("::")) {
					var = buf.substring(0, buf.length() - 2);
				} else {
					double time, from, to;
					try {
						StringTokenizer tk = new StringTokenizer(buf);
						if (tk.countTokens() != 3) {
							//ǡԤǤϤʤΤ̵
							continue;
						}
						time = Double.parseDouble(tk.nextToken());
						from = myParseDouble(tk.nextToken());
						to = myParseDouble(tk.nextToken());
					} catch (NumberFormatException e) {
						//ǡԤǤϤʤΤ̵
						System.out.println(buf);
						continue;
					}
					data.set(time, var, new Interval(from, to));
				}
			}
			data.endBlock();

			//顼ϤϤΤޤ޽ϡ
			BufferedReader errorReader = new BufferedReader(new InputStreamReader(p.getErrorStream()));
			while (true) {
				String data = errorReader.readLine();
				if (data == null) {
					break;
				}
				System.err.println(data);
			}
			//顼λ
			try {
				p.waitFor();
			} catch (InterruptedException e) {
				e.printStackTrace(); // ʤ
				throw new RuntimeException("unexpected interruption", e);
			}
			if (p.exitValue() != 0) {
				shell.getDisplay().asyncExec(new Runnable() {
					public void run() {
						MessageBox b = new MessageBox(shell);
						b.setMessage("execution failure");
						b.open();
					}
				});
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (p != null) {
				p.destroy();
			}
			synchronized(this) {
				executing = false;
			}
			try {
				btnStop.getDisplay().asyncExec(new Runnable() {
					public void run() {
						if (!btnStop.isDisposed()) {
							btnStop.setEnabled(executing);
						}
					}
				});
			} catch (SWTException e) {
				if (e.code != SWT.ERROR_WIDGET_DISPOSED && e.code != SWT.ERROR_DEVICE_DISPOSED) {
					throw e;
				}
			}
		}
	}
	private static double myParseDouble(String str) {
		if (str.equals("-Inf")) {
			return Double.NEGATIVE_INFINITY;
		} else if (str.equals("Inf")) {
			return Double.POSITIVE_INFINITY;
		} else {
			return Double.parseDouble(str);
		}
	}
}
